clc;
clear;

n = 20; % Image size n*n
T = 2000; % The Total time length
bd = 5; % How smooth the defect is (Order of Spline)
k0 = 20; % scale of the background
bd0 = 3; %How smooth the background is (Order of Spline)
k1  = 3; % scale of the defect
ndefect = 1;  % How many defect in the system
delta =0.3; % Defect magnitude
sigma = 0.05; % The noise level
Tin = 1; % When the change occur
Y = zeros(n,n,T); % Generated Videos

m =40; % budget of pixels that can be observed for each image
niter = 20;% iteration of vb
controlimit=inf;
lambda0=0.9;%weigth of historical sample
nrep_oc = 1000;
deltaset=0.1:0.1:1;
ARL_oc=zeros(1,size(deltaset,2));
sdrl_oc=zeros(1,size(deltaset,2));

parpool('local',8);
for dd=1:size(deltaset,2)
    delta=deltaset(dd);
parfor ss=1:nrep_oc
    %generate the background
    knots0 = [ones(1,bd) linspace(1,n,round(n/k0)) n * ones(1,bd0)];
    nKnots0 = length(knots0) - (bd0-1);
    kspline0 = spmak(knots0,eye(nKnots0));
    kd = fnder(kspline0);
    B0=spval(kspline0,1:n)';
    B0 = B0(:,4:end-2);
    B00 = kron(B0,B0);
    mu0 = zeros(1,size(B00,2));
    sigma0 = 0.1;
    Sigma0 = eye(size(B00,2),size(B00,2))*sigma0;
    theta0=zeros(T,size(B00,2));

    % sample IC data
    Y = [];
    theta0(1,:) = mvnrnd(mu0,Sigma0,1);
    for i = 1:T
 
    Y(:,:,i) = reshape(B00*theta0(1,:)',n,n)+ sigma*randn(n);
    end
    
    

    %Generate Defect by Spline Bases (We can change this later if we need to generate other shape of defect
    knots = [ones(1,bd) linspace(1,n,round(n/k1)) n * ones(1,bd)];
    nKnots = length(knots) - (bd-1);
    kspline = spmak(knots,eye(nKnots));
    kd = fnder(kspline);
    B=spval(kspline,1:n)';
    B = B(:,3:end-2);
    kcoef = size(B,2);
    Z = zeros(kcoef);


    for i = 1:ndefect
        Z(randsample(1:kcoef,1),randsample(1:kcoef,1)) = 1;
    end
%     imagesc(Z)

    D = B*Z*B';
%     imagesc(D)

    for i = (Tin+1):T
        Y(:,:,i) = Y(:,:,i)+delta*D;
    end
    Y1 = reshape(Y,n*n,T);
    B = kron(B,B);

    nq = size(B,2); 
    w=0.1*ones(nq,1);
    sigma9=3*ones(nq,1);
    v=10^-7;
    %B_anomaly=eye(n*n);% we just replace it with an identity matrix
%     dd
%     ss
[index_ini,index8,theta8,theta80,Test,runlength]=thom66(Y1',B00,B,m,sigma,niter,w,sigma9,lambda0,controlimit,sigma0);
%[index_ini,index8,theta8,theta80,Test,runlength] = thom2222(Y1',B00,B,m,sigma,niter,w,sigma9,lambda0,controlimit);
TTest(ss,:) = Test;
RRunlength(ss) = runlength;
end

ARL_oc(dd)= mean(RRunlength);
sdrl_oc(dd)=std(RRunlength);
end
delete(gcp('nocreate'))
save('GenerateImages_vb.mat')
%%
%Visualization
theta = theta8;
theta0 = theta80;
index = index8;

figure('position',[40,100,600,800]);
for i = 2:T
Yi = Y(:,:,i);
Xi1 =B*theta(:,i);
Xi = Xi1+B00*theta0(:,i);
subplot(3,2,1);
imagesc(squeeze(Yi));
title('Figure 1:Simulation image','Fontsize',8);
subplot(3,2,2);
imagesc(reshape(Xi,n,n));
title('Figure 2:Fitted image','Fontsize',8);
subplot(3,2,3);
imagesc(reshape(Xi1,n,n));
title('Figure 3:Inferential anomaly point','Fontsize',8);
M = zeros(n,n);
M(index(:,i+1)) = 1;
subplot(3,2,4);
imagesc(M);
title('Figure 4:Sample points','Fontsize',8);
subplot(3,2,[5,6]);
plot(Test(2:i),'-k.','LineWidth',1.5,'MarkerSize',6);
axis([1,200,-10^-3,2*10^-2]);
line([1,200],[6.43*10^-4,6.43*10^-4],'linestyle','--');
text(190,6.43*10^-4,'CL');
title(int2str(i));
pause(0.5);
end
