clc;
clear;
n = 20; % Image size n*n
T = 2000; % The Total time length
bd = 5; % How smooth the defect is (Order of Spline)
k0 = 20; % scale of the background
bd0 = 3;
k1  = 3; % scale of the defect
ndefect = 1; % How many defect in the system
delta =0; % Defect magnitude 
sigma = 0.05; % The noise level
Tin = 1; % When the change occur
Y = zeros(n,n,T); % Generated Videos
nrep =2000;
m =400; % budget of pixels that can be observed for each image
niter = 20; % iteration itmes of vb
lambda0=0.9;
cl=inf;
ARL0=200;%standard normality ARL

parpool('local',12);
parfor ss=1:nrep
    %generate background
    knots0 = [ones(1,bd) linspace(1,n,round(n/k0)) n * ones(1,bd0)];
    nKnots0 = length(knots0) - (bd0-1);
    kspline0 = spmak(knots0,eye(nKnots0));
    kd = fnder(kspline0);
    B0=spval(kspline0,1:n)';
    B0 = B0(:,4:end-2);
    B00 = kron(B0,B0);
    mu0 = zeros(1,size(B00,2));
    sigma0 = 0.1;
    Sigma0 = eye(size(B00,2),size(B00,2))*sigma0;
    theta0=zeros(T,size(B00,2));
    % sample IC data
    Y = [];
    for i = 1:T
    theta0(i,:) = mvnrnd(mu0,Sigma0,1);
    Y(:,:,i) = reshape(B00*theta0(i,:)',n,n)+ sigma*randn(n);
    end
    %generate anomaly bases
    knots = [ones(1,bd) linspace(1,n,round(n/k1)) n * ones(1,bd)];
    nKnots = length(knots) - (bd-1);
    kspline = spmak(knots,eye(nKnots));
    kd = fnder(kspline);
    B=spval(kspline,1:n)';
    B = B(:,3:end-2);
    kcoef = size(B,2);
    Z = zeros(kcoef);

    Y1 = reshape(Y,n*n,T);
    B = kron(B,B);
    nq = size(B,2); 
    w=0.1*ones(nq,1);
    sigma9=3*ones(nq,1);
    v=1.5;
    ss
[index_ini,index8,theta8,theta80,Test,runlength] = thom66(Y1',B00,B,m,sigma,niter,w,sigma9,lambda0,cl,sigma0,v);

TTest(ss,:) = Test;
plot(TTest(ss,:));%verify if the test statistic is stable
RRunlength(ss) = runlength;
end  

%% we use dichotomy to decide the control limit
TTest(:,1)=[];%since we sample all points at the first time point, so we should delete it here
CLmax=max(TTest(:));
CLmin=0;
cl=CLmax;
bia=1;%the tolerance to the standard normal ARL
ARL(1)=0;
ARL(2)=mean(RRunlength);
TTest1=TTest';
i=2;
while(abs(ARL(i)-ARL0)>bia && abs(CLmax-CLmin)>10^-5)
    if ARL(i)>ARL0
        CLmax=cl;
        cl=0.5*(CLmax+CLmin);
    else
        CLmin=cl;
        cl=0.5*(CLmax+CLmin);
    end
    i=i+1;
    TTest2=TTest1;
    TTest2(abs(TTest1)<=cl)=0;
     aa=sum(all(TTest2==0));% if all columns are zeros, it indicates that RL of this replication is T,so we should add them all.
    [u,v]=find(TTest2);
    ARL(i)=(sum(u(diff([0;v])~=0))+aa*(size(TTest2,1)+1))/size(TTest2,2);
    ARL(i)
end
fprintf('ARL of in-control process is %f\n',ARL(i))
fprintf('The controlimit is %f',cl)
save('GenerateImages_vb_findcl.mat')
delete(gcp('nocreate'))