clc;
clear;

n = 100; % Image size n*n
T = 2000; % The Total time length
bd = 4; % How smooth the defect is (Order of Spline)
k0 = 20; % scale of the background
bd0 = 3;
nq0 = 3;
k1  = 2; % scale of the defect
ndefect = 1;  % How many defect in the system
delta =0; % Defect magnitude
sigma = 0.05; % The noise level
Tin = 1; % When the change occur
Y = zeros(n,n,T); % Generated Videos

m=10; % budget of pixels that can be observed for each image
niter=50;
lambda0=0.9;
nrep =1000;
controlimit=10;
ARL0=200;

parpool('local',8);
parfor ss=1:nrep
    knots0 = [ones(1,bd) linspace(1,n,round(n/k0)) n * ones(1,bd0)];
    nKnots0 = length(knots0) - (bd0-1);   
    kspline0 = spmak(knots0,eye(nKnots0));
    kd = fnder(kspline0);
    B0=spval(kspline0,1:n)';
     B0 = fourierbasis(nq0,n);
    B00 = B0;
    mu0 = zeros(1,size(B00,2));
    sigma0 = 0.1;
    Sigma0 = eye(size(B00,2),size(B00,2))*sigma0;
    theta0 = zeros(T,size(B00,2));
    % sample IC data
    Y = [];
    for i = 1:T
    theta0(i,:) = mvnrnd(mu0,Sigma0,1);
    Y(:,i) = B00*theta0(i,:)'+ sigma*randn(n,1);
    end
  
    %Generate Defect by Spline Bases (We can change this later if we need to generate other shape of defect
    knots = [ones(1,bd) linspace(1,n,round(n/k1)) n * ones(1,bd)];
    nKnots = length(knots) - (bd-1);
    kspline = spmak(knots,eye(nKnots));
    kd = fnder(kspline);
    B=spval(kspline,1:n)';
    B = B(:,3:end-2);
    kcoef = size(B,2);
    Z = zeros(kcoef,1);


    for i = 1:ndefect
        Z(randsample(1:kcoef,1)) = 1;
    end
    %imagesc(Z)

    D = B*Z;
    %imagesc(D)

    for i = (Tin+1):T
        Y(:,i) = Y(:,i)+delta*D;
    end
     Y1 = Y;
    nq = size(B,2); 
    w=0.1*ones(nq,1);
    sigma9=3*ones(nq,1);
    %v=0.0000001;
    ss
[~,index8,theta8,theta80,Test,runlength] = thom66(Y1',B00,B,m,sigma,niter,w,sigma9,lambda0,controlimit,sigma0);

TTest(ss,:) = Test;
plot(TTest(ss,:));
RRunlength(ss) = runlength;
end

TTest(:,1)=[];
CLmax=max(TTest(:));
CLmin=0;
cl=CLmax;
bia=1;
ARL(1)=0;
ARL(2)=mean(RRunlength);
TTest1=TTest';
i=2;
while(abs(ARL(i)-ARL0)>bia && abs(CLmax-CLmin)>10^-5)
    if ARL(i)>ARL0
        CLmax=cl;
        cl=0.5*(CLmax+CLmin);
    else
        CLmin=cl;
        cl=0.5*(CLmax+CLmin);
    end
    i=i+1;
    TTest2=TTest1;
    TTest2(abs(TTest1)<=cl)=0;
    aa=sum(all(TTest2==0));
    [u,v]=find(TTest2);
    ARL(i)=(sum(u(diff([0;v])~=0))+aa*(size(TTest2,1)+1))/size(TTest2,2);
    ARL(i)
end
fprintf('ARL of in-control process is %f\n',ARL(i))
fprintf('The controlimit is %f',cl)
save('GenerateVector_findcl.mat')
delete(gcp('nocreate'))