clc;
clear;
load data.mat
Y = data;
nx = size(Y,1);
ny = size(Y,2);
nt = size(Y,3);
p=nx*ny;
Y=reshape(Y,p,nt);
Y=(Y-mean(Y,2))./std(Y,0,2);%standardization

Y0=Y;
Y0(:,187:202)=[];
Y0(:,200:252)=[];%delete the probable anomaly data
ntt=size(Y0,2);
[coeff,score,latent,tsquared,explained,mu]=pca(Y0','NumComponents',20);%use pca to decide sigma of noise and B00
fit=score*coeff'+repmat(mu,ntt,1);
noise=Y0'-fit;
sq=(noise-mean(noise)).^2;
sigma=sqrt(sum(sq(:))/(p*ntt));%standard deviation of noise 
B00=coeff;% normal bases 
cov_theta=cov(score);
sigma0=mean(diag(cov_theta));

skx = round(nx/15);% knots of bspline
B= bsplineBasis(ny,skx,3);
B=kron(B,B);%first generate length of 292*292 bases
for i=1:292
    B((232*i+1):(232*(i-1)+292),:)=[];
end % then delete the excess length to 232*292 bases, to do this we want to use a circle group of  points to fit anomaly patterns in visualization part
B(:,[15,16,31,32,47,48,63,64,79,80,95,96,111,112,127,128,143,144,159,160,175,176,191,192,207,208,223,224,239,240,255,256])=[];

m = 400;%number of sample points
niter = 30;
controlimit=20;% the control limit that we have found to make the standard in-control ARL=1100
lambda0=0.9;
nq = size(B,2);
w=0.1*ones(nq,1);
sigma9=10*ones(nq,1);
YY=Y(:,101:nt);
YY=YY-repmat(mu,nt-100,1)';
rng(1);
[index_ini,index8,theta8,theta80,Test,runlength] = thom66(YY',B00,B,m,sigma,niter,w,sigma9,lambda0,controlimit,sigma0);

%% visualization
theta = theta8;
theta0 = theta80;
index = index8;
YU=reshape(YY,nx,ny,(nt-100));

figure('position',[40,100,800,650]);
for i=2:89
Yi = YU(:,:,i);
Xi1 =B*theta(:,i);
Xi = B00*theta0(:,i);
subplot(2,2,1);
imagesc(squeeze(Yi));
subplot(2,2,2);
imagesc(reshape(Xi,nx,ny));
subplot(2,2,3);
imagesc(reshape(Xi1,nx,ny));
 title(int2str(i));
M = zeros(nx,ny);
M(index(:,i)) = 1;
subplot(2,2,4);
imagesc(M);
pause(0.5);
end
